/*!
 * @file connection_monitor.h
    \brief interface for all classes that have to be synchronized
 */

#ifndef _SYNCHRONIZEABLE_H
#define _SYNCHRONIZEABLE_H

#include "base_object.h"
#include "netdefs.h"
#include "converter.h"



#include <vector>
#include <list>

//State constants: They have to be of the form 2^n
#define STATE_SERVER 1
#define STATE_OUTOFSYNC 2
#define STATE_REQUESTEDSYNC 4

//macros to help writing data in byte buffer
#define SYNCHELP_WRITE_BEGIN() {  int __synchelp_write_i = 0; \
                                  bool __synchelp_write_err = false; \
                                  int __synchelp_write_n; }
#define SYNCHELP_WRITE_RESET() { __synchelp_write_i = 0; __synchelp_write_err = false; }
#define SYNCHELP_WRITE_INT(i) { __synchelp_write_n =  }
#define SYNCHELP_WIRTE_FLOAT()
#define SYNCHELP_WRITE_BYTE()
#define SYNCHELP_WRITE_STRING()

class NetworkStream;


class Synchronizeable : virtual public BaseObject
  {
  public:
    Synchronizeable();
    ~Synchronizeable();

    virtual void      writeBytes(const byte* data, int length, int sender);
    virtual int       readBytes(byte* data, int maxLength, int * reciever);
    virtual void      writeDebug() const;
    virtual void      readDebug() const;

    void setIsServer( bool isServer );
    void setIsOutOfSync( bool outOfSync );
    void setRequestedSync( bool requestedSync );
    bool isServer();
    bool isOutOfSync();
    bool requestedSync();
    inline void setUniqueID( int id ){ uniqueID = id; }
    inline int  getUniqueID() const { return uniqueID; };
    inline void requestSync( int hostID ){ this->synchronizeRequests.push_back( hostID ); }
    inline int getRequestSync( void ){ if ( this->synchronizeRequests.size()>0 ){ int n = *(synchronizeRequests.begin()); synchronizeRequests.pop_front(); return n; } else { return -1; } };
    inline int getHostID() { return this->hostID; }

    inline int getOwner(){ return owner; }
    inline void setOwner(int owner){ this->owner = owner; }

    inline void setNetworkStream(NetworkStream* stream) { this->networkStream = stream; }

  private:

    int               uniqueID;



    //static std::vector<Synchronizeable*> classList;
    int owner;
    int hostID;

    std::list<int> synchronizeRequests;

  protected:
    NetworkStream* networkStream;
    int state;

  };
#endif /* _SYNCHRONIZEABLE_H */
